#include <iostream>
#ifdef _WIN32
    #include <windows.h>
    #include <dlfcn.h>
#else
    #include <dlfcn.h>
#endif

int main()
{
    std::string a = "your_dll.dll";
//    if (a != "a") {
//        // 这个条件语句块目前为空，如果需要可以添加相关逻辑
//    }
//#ifdef _WIN32
    std::wstring wideDLLName(a.begin(), a.end()); // C++11及以后版本可以直接转换
//    std::string a = "aa";
//    std::wstring wideA(a.begin(), a.end());
//    if(wideDLLName == wideA){
//    }
    std::wstring wideDLLName(a.begin(), a.end());
    HINSTANCE hInst = LoadLibrary(wideDLLName.c_str());//error
    if (hInst == NULL) {
        std::cout << "无法加载库" << std::endl;
        return -1;
    }

    typedef void (*FuncType)();
    FuncType func = (FuncType)GetProcAddress(hInst, "函数名称");
    if (func == NULL) {
        std::cout << "无法获取函数" << std::endl;
        FreeLibrary(hInst);
        return -1;
    }

    func();
    FreeLibrary(hInst);
//#else
    std::string b = "c";
//    if (b != "a") {
//        // 这个条件语句块目前为空，如果需要可以添加相关逻辑
//    }

    void *handle = dlopen(b.c_str(), RTLD_LAZY);//error
    if (!handle) {
        std::cerr << "无法打开库：" << dlerror() << '\n';
        return 1;
    }

    dlerror(); // 清除上一次调用产生的错误信息
    typedef void (*FuncType)();
    FuncType func = (FuncType)dlsym(handle, "函数名称");
    const char *dlsym_error = dlerror();
    if (dlsym_error) {
        std::cerr << "无法加载符号 '函数名称'：" << dlsym_error << '\n';
        dlclose(handle);
        return 1;
    }

    func();
    dlclose(handle);
//#endif

    return 0;
}